kconfig: Simplify Makefile
[deliverable/linux.git] / scripts / kconfig / Makefile
CommitLineData
1da177e4
LT
1# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
1cba0c30 5PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
281c9dad 6 localmodconfig localyesconfig
1da177e4 7
61bee204
AV
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
838a2e55 11Kconfig := Kconfig
61bee204 12endif
e703f75d 13
c2838e6e
YM
14# We need this, in case the user has it in its environment
15unexport CONFIG_
16
1da177e4 17xconfig: $(obj)/qconf
e703f75d 18 $< $(Kconfig)
1da177e4
LT
19
20gconfig: $(obj)/gconf
e703f75d 21 $< $(Kconfig)
1da177e4
LT
22
23menuconfig: $(obj)/mconf
e703f75d 24 $< $(Kconfig)
1da177e4
LT
25
26config: $(obj)/conf
4062f1a4 27 $< --oldaskconfig $(Kconfig)
1da177e4 28
692d97c3 29nconfig: $(obj)/nconf
30 $< $(Kconfig)
31
1da177e4 32silentoldconfig: $(obj)/conf
9815594a 33 $(Q)mkdir -p include/config include/generated
4062f1a4 34 $< --$@ $(Kconfig)
1da177e4 35
50bce3e8 36localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
9815594a 37 $(Q)mkdir -p include/config include/generated
22d550ae 38 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
7a996d3a 39 $(Q)if [ -f .config ]; then \
4062f1a4
SR
40 cmp -s .tmp.config .config || \
41 (mv -f .config .config.old.1; \
42 mv -f .tmp.config .config; \
43 $(obj)/conf --silentoldconfig $(Kconfig); \
44 mv -f .config.old.1 .config.old) \
45 else \
46 mv -f .tmp.config .config; \
47 $(obj)/conf --silentoldconfig $(Kconfig); \
a7c02602 48 fi
03fa25da
SR
49 $(Q)rm -f .tmp.config
50
1020026f 51# Create new linux.pot file
b70e325c 52# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
46d26319 53update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
e2aef4d3 54 $(Q)echo " GEN config.pot"
a24a1b8e
PF
55 $(Q)xgettext --default-domain=linux \
56 --add-comments --keyword=_ --keyword=N_ \
57 --from-code=UTF-8 \
58 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
59 --directory=$(srctree) --directory=$(objtree) \
b70e325c
SR
60 --output $(obj)/config.pot
61 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
fa0ad657
PB
62 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
63 $(srctree)/arch/*/um/Kconfig`; \
1020026f 64 do \
e2aef4d3 65 echo " GEN $$i"; \
4217516e 66 $(obj)/kxgettext $$i \
1020026f
EG
67 >> $(obj)/config.pot; \
68 done )
e2aef4d3 69 $(Q)echo " GEN linux.pot"
1020026f 70 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
b70e325c 71 --output $(obj)/linux.pot
b70e325c 72 $(Q)rm -f $(obj)/config.pot
3b9fa093 73
1cba0c30
MM
74# These targets map 1:1 to the commandline options of 'conf'
75simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
76 alldefconfig randconfig listnewconfig olddefconfig
77PHONY += $(simple-targets)
1da177e4 78
1cba0c30 79$(simple-targets): $(obj)/conf
4062f1a4 80 $< --$@ $(Kconfig)
1da177e4 81
1cba0c30 82PHONY += oldnoconfig savedefconfig defconfig
1da177e4 83
fb16d891
AL
84# oldnoconfig is an alias of olddefconfig, because people already are dependent
85# on its behavior(sets new symbols to their default value but not 'n') with the
86# counter-intuitive name.
1cba0c30 87oldnoconfig: olddefconfig
fb16d891 88
7cf3d73b
SR
89savedefconfig: $(obj)/conf
90 $< --$@=defconfig $(Kconfig)
91
1da177e4
LT
92defconfig: $(obj)/conf
93ifeq ($(KBUILD_DEFCONFIG),)
4062f1a4 94 $< --defconfig $(Kconfig)
1da177e4 95else
2266cfd5 96 @echo "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
4062f1a4 97 $(Q)$< --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
1da177e4
LT
98endif
99
100%_defconfig: $(obj)/conf
4062f1a4 101 $(Q)$< --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
1da177e4 102
63a91033 103configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
3aaefce1 104
63a91033
MY
105%.config: $(obj)/conf
106 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
107 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
108 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
3aaefce1
JT
109
110PHONY += kvmconfig
63a91033
MY
111kvmconfig: kvm_guest.config
112 @:
3aaefce1 113
0da1d4a0 114PHONY += tinyconfig
63a91033
MY
115tinyconfig:
116 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
0da1d4a0 117
1da177e4
LT
118# Help text used by make help
119help:
120 @echo ' config - Update current config utilising a line-oriented program'
692d97c3 121 @echo ' nconfig - Update current config utilising a ncurses menu based program'
1da177e4
LT
122 @echo ' menuconfig - Update current config utilising a menu based program'
123 @echo ' xconfig - Update current config utilising a QT based front-end'
124 @echo ' gconfig - Update current config utilising a GTK based front-end'
125 @echo ' oldconfig - Update current config utilising a provided .config as base'
03fa25da 126 @echo ' localmodconfig - Update current config disabling modules not loaded'
281c9dad 127 @echo ' localyesconfig - Update current config converting local mods to core'
590a5857 128 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
0748cb3e 129 @echo ' defconfig - New config with default from ARCH supplied defconfig'
7cf3d73b 130 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
e11f0496 131 @echo ' allnoconfig - New config where all options are answered with no'
0748cb3e
SR
132 @echo ' allyesconfig - New config where all options are accepted with yes'
133 @echo ' allmodconfig - New config selecting modules when possible'
134 @echo ' alldefconfig - New config with all symbols set to default'
135 @echo ' randconfig - New config with random answer to all options'
861b4ea4 136 @echo ' listnewconfig - List new options'
fb16d891 137 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their default value'
3aaefce1 138 @echo ' kvmconfig - Enable additional options for guest kernel support'
0da1d4a0 139 @echo ' tinyconfig - Configure the tiniest possible kernel'
1da177e4 140
2982de69
SR
141# lxdialog stuff
142check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
143
e9e40e14 144# Use recursively expanded variables so we do not call gcc unless
2982de69 145# we really need to do so. (Do not call gcc as part of make mrproper)
9ba95682
AL
146HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
147 -DLOCALE
2982de69 148
1da177e4
LT
149# ===========================================================================
150# Shared Makefile for the various kconfig executables:
151# conf: Used for defconfig, oldconfig and related targets
692d97c3 152# nconf: Used for the nconfig target.
153# Utilizes ncurses
6f26e5e4 154# mconf: Used for the menuconfig target
1da177e4
LT
155# Utilizes the lxdialog package
156# qconf: Used for the xconfig target
157# Based on QT which needs to be installed to compile it
158# gconf: Used for the gconfig target
159# Based on GTK which needs to be installed to compile it
160# object files used by all kconfig flavours
161
2982de69
SR
162lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
163lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
164
1da177e4 165conf-objs := conf.o zconf.tab.o
692d97c3 166mconf-objs := mconf.o zconf.tab.o $(lxdialog)
167nconf-objs := nconf.o zconf.tab.o nconf.gui.o
3b9fa093 168kxgettext-objs := kxgettext.o zconf.tab.o
f1943049 169qconf-cxxobjs := qconf.o
5a6f8d2b
AL
170qconf-objs := zconf.tab.o
171gconf-objs := gconf.o zconf.tab.o
1da177e4 172
022af62d 173hostprogs-y := conf nconf mconf kxgettext qconf gconf
1da177e4 174
5a6f8d2b 175clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
2f76b358 176clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
1020026f 177clean-files += config.pot linux.pot
1da177e4 178
6e588f6d
SR
179# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
180PHONY += $(obj)/dochecklxdialog
181$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
182$(obj)/dochecklxdialog:
7080e47b 183 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
6e588f6d
SR
184
185always := dochecklxdialog
186
aa1e5ef5
SR
187# Add environment specific flags
188HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
70a6a0cb 189
1da177e4 190# generated files seem to need this to find local include files
2f76b358 191HOSTCFLAGS_zconf.lex.o := -I$(src)
1da177e4
LT
192HOSTCFLAGS_zconf.tab.o := -I$(src)
193
378dbb2c
AL
194LEX_PREFIX_zconf := zconf
195YACC_PREFIX_zconf := zconf
196
5a6f8d2b
AL
197HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
198HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
1da177e4 199
5a6f8d2b 200HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
37193147 201HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
1ea3ad4e 202 -Wno-missing-prototypes
1da177e4 203
7080e47b
AL
204HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
205
544e7e54 206HOSTLOADLIBES_nconf = $(shell \
7285996a
BN
207 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
208 || pkg-config --libs menu panel ncurses 2>/dev/null \
544e7e54 209 || echo "-lmenu -lpanel -lncurses" )
1da177e4
LT
210$(obj)/qconf.o: $(obj)/.tmp_qtcheck
211
022af62d 212ifeq ($(MAKECMDGOALS),xconfig)
b3a5225f 213$(obj)/.tmp_qtcheck: $(src)/Makefile
1da177e4
LT
214-include $(obj)/.tmp_qtcheck
215
216# QT needs some extra effort...
217$(obj)/.tmp_qtcheck:
b3a5225f 218 @set -e; echo " CHECK qt"; dir=""; pkg=""; \
133c5f7c
AS
219 if ! pkg-config --exists QtCore 2> /dev/null; then \
220 echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
221 pkg-config --exists qt 2> /dev/null && pkg=qt; \
222 pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
223 if [ -n "$$pkg" ]; then \
224 cflags="\$$(shell pkg-config $$pkg --cflags)"; \
225 libs="\$$(shell pkg-config $$pkg --libs)"; \
226 moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
227 dir="$$(pkg-config $$pkg --variable=prefix)"; \
228 else \
229 for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
230 if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
231 done; \
232 if [ -z "$$dir" ]; then \
5b580fa6
MM
233 echo >&2 "*"; \
234 echo >&2 "* Unable to find any QT installation. Please make sure that"; \
235 echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
236 echo >&2 "* either qmake can be found or install pkg-config or set"; \
237 echo >&2 "* the QTDIR environment variable to the correct location."; \
238 echo >&2 "*"; \
133c5f7c
AS
239 false; \
240 fi; \
241 libpath=$$dir/lib; lib=qt; osdir=""; \
242 $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
243 osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
244 test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
245 test -f $$libpath/libqt-mt.so && lib=qt-mt; \
246 cflags="-I$$dir/include"; \
247 libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
248 moc="$$dir/bin/moc"; \
249 fi; \
250 if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
251 echo "*"; \
252 echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
253 echo "*"; \
254 moc="/usr/bin/moc"; \
255 fi; \
ab919c06 256 else \
458452f4
MM
257 cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
258 libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
48485949
YS
259 moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
260 [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
b3a5225f
RZ
261 fi; \
262 echo "KC_QT_CFLAGS=$$cflags" > $@; \
263 echo "KC_QT_LIBS=$$libs" >> $@; \
264 echo "KC_QT_MOC=$$moc" >> $@
1da177e4
LT
265endif
266
267$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
268
022af62d 269ifeq ($(MAKECMDGOALS),gconfig)
1da177e4
LT
270-include $(obj)/.tmp_gtkcheck
271
272# GTK needs some extra effort, too...
273$(obj)/.tmp_gtkcheck:
37193147
AB
274 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
275 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
1da177e4
LT
276 touch $@; \
277 else \
5b580fa6
MM
278 echo >&2 "*"; \
279 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
280 echo >&2 "*"; \
1da177e4
LT
281 false; \
282 fi \
283 else \
5b580fa6
MM
284 echo >&2 "*"; \
285 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
286 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
287 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
288 echo >&2 "*"; \
1da177e4
LT
289 false; \
290 fi
291endif
292
2f76b358 293$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
1da177e4 294
5a6f8d2b 295$(obj)/qconf.o: $(obj)/qconf.moc
1da177e4 296
ebca026a
YS
297quiet_cmd_moc = MOC $@
298 cmd_moc = $(KC_QT_MOC) -i $< -o $@
299
300$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
301 $(call cmd,moc)
1da177e4 302
46d26319
EG
303# Extract gconf menu items for I18N support
304$(obj)/gconf.glade.h: $(obj)/gconf.glade
2d80eb0f 305 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
a24a1b8e 306 $(obj)/gconf.glade
This page took 0.711507 seconds and 5 git commands to generate.